## mingw-w64-aws-sdk-cpp-1.11.271-1.src.tar.zst

=== CMakeLists.txt ===
# Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
# SPDX-License-Identifier: Apache-2.0.
#

cmake_minimum_required(VERSION 3.13 FATAL_ERROR)

option(LEGACY_BUILD "If enabled, the SDK will use 1.11.0 version of CMake files to build" ON)
if (LEGACY_BUILD)
    message(WARNING "In 1.11 releases, we are releasing experimental alternative building mode."
            "By setting -DLEGACY_MODE=OFF you can test our advances in modern CMake building and "
            "provide early feedback. "
            "The legacy support is set by default in 1.11, when you complete build updating scripts please "
            "update the build flags as mentioned in README.md and set -DLEGACY_BUILD=OFF. "
            "The legacy support will be removed at 1.12.0 release.")

    if (POLICY CMP0077)
        cmake_policy(SET CMP0077 OLD) # CMP0077: option() honors normal variables. Introduced in 3.13
    endif ()

    get_filename_component(AWS_NATIVE_SDK_ROOT "${CMAKE_CURRENT_SOURCE_DIR}" ABSOLUTE)

    # Cmake invocation variables:
    #   BUILD_ONLY - only build project identified by this variable, a semi-colon delimited list, if this is set we will build only the projects listed. Core will always be built as will its unit tests.
    #                    Also if a high level client is specified then we will build its dependencies as well. If a project has tests, the tests will be built.
    #   ADD_CUSTOM_CLIENTS - semi-colon delimited list of format serviceName=<yourServiceName>,version=<theVersionNumber>;serviceName2=<yourOtherServiceName>,version=<versionNumber2>
    #                          to use these arguments, you should add the api definition .normal.json file for your service to the api-description folder in the generator.
    #   NDK_DIR - directory where the android NDK is installed; if not set, the location will be read from the ANDROID_NDK environment variable
    #   CUSTOM_PLATFORM_DIR - directory where custom platform scripts, modules, and source resides
    #   AWS_SDK_ADDITIONAL_LIBRARIES - names of additional libraries to link into aws-cpp-sdk-core in order to support unusual/unanticipated linking setups (static curl against static-something-other-than-openssl for example)

    option(ENABLE_UNITY_BUILD "If enabled, the SDK will be built using a single unified .cpp file for each service library.  Reduces the size of static library binaries on Windows and Linux" ON)
    option(MINIMIZE_SIZE "If enabled, the SDK will be built via a unity aggregation process that results in smaller static libraries; additionally, release binaries will favor size optimizations over speed" OFF)
    option(BUILD_SHARED_LIBS "If enabled, all aws sdk libraries will be build as shared objects; otherwise all Aws libraries will be built as static objects" ON)
    option(FORCE_SHARED_CRT "If enabled, will unconditionally link the standard libraries in dynamically, otherwise the standard library will be linked in based on the BUILD_SHARED_LIBS setting" ON)
    option(SIMPLE_INSTALL "If enabled, removes all the additional indirection (platform/cpu/config) in the bin and lib directories on the install step" ON)
    option(USE_CRT_HTTP_CLIENT "If enabled, the common runtime HTTP client will be used, and the legacy systems such as WinHttp and libcurl will not be built or included" OFF)
    option(NO_HTTP_CLIENT "If enabled, no platform-default http client will be included in the library.  For the library to be used you will need to provide your own platform-specific implementation" OFF)
    option(NO_ENCRYPTION "If enabled, no platform-default encryption will be included in the library.  For the library to be used you will need to provide your own platform-specific implementations" OFF)
    option(USE_IXML_HTTP_REQUEST_2 "If enabled on windows, the com object IXmlHttpRequest2 will be used for the http stack" OFF)
    option(ENABLE_RTTI "Flag to enable/disable rtti within the library" ON)
    option(ENABLE_TESTING "Flag to enable/disable building unit and integration tests" ON)
    option(AUTORUN_UNIT_TESTS "Flag to enable/disable automatically run unit tests after building" ON)
    option(ANDROID_BUILD_CURL "When building for Android, should curl be built as well" ON)
    option(ANDROID_BUILD_OPENSSL "When building for Android, should Openssl be built as well" ON)
    option(ANDROID_BUILD_ZLIB "When building for Android, should Zlib be built as well" ON)
    option(FORCE_CURL "Forces usage of the Curl client rather than the default OS-specific api" OFF)
    option(ENABLE_ADDRESS_SANITIZER "Flags to enable/disable Address Sanitizer for gcc or clang" OFF)
    option(BYPASS_DEFAULT_PROXY "Bypass the machine's default proxy settings when using IXmlHttpRequest2" ON)
    option(BUILD_DEPS "Build third-party dependencies" ON)
    option(USE_OPENSSL "Set this if you want to use your system's OpenSSL 1.0.2/1.1.1 compatible libcrypto" ON)
    option(ENABLE_CURL_LOGGING "If enabled, Curl's internal log will be piped to SDK's logger" ON)
    option(ENABLE_HTTP_CLIENT_TESTING "If enabled, corresponding http client test suites will be built and run" OFF)
    option(CUSTOM_MEMORY_MANAGEMENT "If set to ON, generates the sdk project files with custom memory management enabled, otherwise disables it" OFF)
    option(REGENERATE_CLIENTS "If set to ON, all clients being built on this run will be regenerated from the api definitions, this option involves some setup of python, java 8+, and maven" OFF)
    option(ENABLE_VIRTUAL_OPERATIONS "This option usually works with REGENERATE_CLIENTS. \
                                If enabled when doing code generation, operation related functions in service clients will be marked as virtual. \
                                If disabled when doing code generation, virtual will not be added to operation functions and service client class will be marked as final. \
                                If disabled, SDK will add compiler flags '-ffunction-sections -fdata-sections' for gcc and clang when compiling. \
                                You can utilize this feature to work with your linker to reduce binary size of your application on Unix platforms when doing static linking in Release mode." ON)
    option(REGENERATE_DEFAULTS "If set to ON, defaults mode configuration will be regenerated from the JSON definitions, this option involves some setup of python, java 8+, and maven" OFF)
    option(ENABLE_ZLIB_REQUEST_COMPRESSION "For services that support it, request content will be compressed. On by default if dependency available" ON)
    option(DISABLE_INTERNAL_IMDSV1_CALLS "Disables IMDSv1 internal client calls" OFF)
    option(BUILD_BENCHMARKS "Enables building the benchmark executable" OFF)
    option(BUILD_OPTEL "Enables building the open telemetry implementation of tracing" OFF)
    option(AWS_SDK_WARNINGS_ARE_ERRORS "Compiler warning is treated as an error. Try turning this off when observing errors on a new or uncommon compiler" ON)
    option(BUILD_OPTEL_OTLP_BENCHMARKS "Enables building the benchmark tests with open telemetry OTLP clients" OFF)
    option(USE_TLS_V1_2 "Set http client to enforce TLS 1.2" ON)
    option(USE_TLS_V1_3 "Set http client to enforce TLS 1.3" OFF)
    option(AWS_USE_CRYPTO_SHARED_LIBS "Forces FindCrypto to use a shared crypto library if found. regardless of the value of BUILD_SHARED_LIBS" OFF)

    set(AWS_USER_AGENT_CUSTOMIZATION "" CACHE STRING "User agent extension")
    set(AWS_TEST_REGION "US_EAST_1" CACHE STRING "Region to target integration tests against")
    set(AWS_AUTORUN_LD_LIBRARY_PATH CACHE STRING "Path to append into LD_LIBRARY_PATH for unit tests autorun by cmake. Set this if custom runtime libs are required for overridden dependencies.")
    set(BUILD_ONLY "" CACHE STRING "A semi-colon delimited list of the projects to build")
    set(CPP_STANDARD "11" CACHE STRING "Flag to upgrade the C++ standard used. The default is 11. The minimum is 11.")

    get_property(is_multi_config GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
    if (NOT ${is_multi_config})
        set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Release build by default.")
    endif ()
    if (DISABLE_INTERNAL_IMDSV1_CALLS)
        add_definitions(-DDISABLE_IMDSV1)
    endif ()
    if (USE_TLS_V1_2)
        add_definitions(-DENFORCE_TLS_V1_2)
    endif ()
    if (USE_TLS_V1_3)
        add_definitions(-DENFORCE_TLS_V1_3)
    endif ()

    #From https://stackoverflow.com/questions/18968979/how-to-get-colorized-output-with-cmake
    if (NOT WIN32)
        string(ASCII 27 Esc)
        set(ColourReset "${Esc}[m")
        set(ColourBold "${Esc}[1m")
        set(Red "${Esc}[31m")
        set(Green "${Esc}[32m")
        set(Yellow "${Esc}[33m")
        set(Blue "${Esc}[34m")
        set(Magenta "${Esc}[35m")
        set(Cyan "${Esc}[36m")
        set(White "${Esc}[37m")
        set(BoldRed "${Esc}[1;31m")
        set(BoldGreen "${Esc}[1;32m")
        set(BoldYellow "${Esc}[1;33m")
        set(BoldBlue "${Esc}[1;34m")
        set(BoldMagenta "${Esc}[1;35m")
        set(BoldCyan "${Esc}[1;36m")
        set(BoldWhite "${Esc}[1;37m")
    endif ()

    if (NOT USE_OPENSSL)
        message(WARNING "Turning off USE_OPENSSL will install AWS-LC as replacement of OpenSSL in the system default directory. This is an experimental feature. Do not use if you have an OpenSSL installation in your system already.")
    endif ()

    # backwards compatibility with old command line params
    if ("${STATIC_LINKING}" STREQUAL "1")
        set(BUILD_SHARED_LIBS OFF)
    endif ()

    if (MINIMIZE_SIZE)
        message(STATUS "MINIMIZE_SIZE enabled")
        set(ENABLE_UNITY_BUILD ON) # MINIMIZE_SIZE always implies UNITY_BUILD
    endif ()

    set(PYTHON_CMD "python")

    # CMAKE_MODULE_PATH is a CMAKE variable. It contains a list of paths
    # which could be used to search CMAKE modules by "include()" or "find_package()", but the default value is empty.
    # Add ${CMAKE_INSTALL_LIBDIR}/cmake and ${CMAKE_PREFIX_PATH}/lib/cmake to search list
    list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")
    set(AWS_MODULE_DIR "/${CMAKE_INSTALL_LIBDIR}/cmake")
    string(REPLACE ";" "${AWS_MODULE_DIR};" AWS_MODULE_PATH "${CMAKE_PREFIX_PATH}${AWS_MODULE_DIR}")
    list(APPEND CMAKE_MODULE_PATH ${AWS_MODULE_PATH})

    # include() will "load and run" cmake script
    include(resolve_platform)
    include(CMakePackageConfigHelpers)

    if (REGENERATE_CLIENTS AND NOT ENABLE_VIRTUAL_OPERATIONS)
        if (PLATFORM_LINUX OR PLATFORM_APPLE)
            Message(STATUS "${BoldYellow}You are regenerating service client's source code and is turning ENABLE_VIRTUAL_OPERATIONS off. If you are targeting smaller binary size, read description string of ENABLE_VIRTUAL_OPERATIONS.${ColourReset}")
        endif ()
    endif ()

    # use response files to prevent command-line-too-big errors for large libraries like iam
    set(CMAKE_CXX_USE_RESPONSE_FILE_FOR_OBJECTS 1)
    set(CMAKE_CXX_USE_RESPONSE_FILE_FOR_INCLUDES 1)
    set(CMAKE_CXX_RESPONSE_FILE_LINK_FLAG "@")

    if (COMMAND apply_pre_project_platform_settings)
        apply_pre_project_platform_settings()
    endif ()

    include(initialize_project_version)

    if (BUILD_SHARED_LIBS OR FORCE_SHARED_CRT)
        set(STATIC_CRT OFF)
    else ()
        set(STATIC_CRT ON)
    endif ()

    # Add Linker search paths to RPATH so as to fix the problem where some linkers can't find cross-compiled dependent libraries in customer paths when linking executables.
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH true)

    # build the sdk targets
    project("aws-cpp-sdk-all" VERSION "${PROJECT_VERSION}" LANGUAGES CXX)

    set(Python_ADDITIONAL_VERSIONS 3.7 3.8 3.9 3.10)
    find_package(PythonInterp)
    set(PYTHON3_CMD ${PYTHON_EXECUTABLE})

    # ENABLE_ZLIB_REQUEST_COMPRESSION should be ON by default if ZLIB is available
    if(ENABLE_ZLIB_REQUEST_COMPRESSION)
        find_package(ZLIB QUIET)
        if ( NOT ZLIB_FOUND)

=== generated/src/aws-cpp-sdk-auditmanager/CMakeLists.txt ===
add_project(aws-cpp-sdk-auditmanager "C++ SDK for the AWS auditmanager service" aws-cpp-sdk-core)

file(GLOB AWS_AUDITMANAGER_HEADERS
    "include/aws/auditmanager/*.h"
)

file(GLOB AWS_AUDITMANAGER_MODEL_HEADERS
    "include/aws/auditmanager/model/*.h"
)

file(GLOB AWS_AUDITMANAGER_SOURCE
    "source/*.cpp"
)

file(GLOB AWS_AUDITMANAGER_MODEL_SOURCE
    "source/model/*.cpp"
)

file(GLOB AUDITMANAGER_UNIFIED_HEADERS
    ${AWS_AUDITMANAGER_HEADERS}
    ${AWS_AUDITMANAGER_MODEL_HEADERS}
)

file(GLOB AUDITMANAGER_UNITY_SRC
    ${AWS_AUDITMANAGER_SOURCE}
    ${AWS_AUDITMANAGER_MODEL_SOURCE}
)

if(ENABLE_UNITY_BUILD)
    enable_unity_build("AUDITMANAGER" AUDITMANAGER_UNITY_SRC)
endif()

file(GLOB AUDITMANAGER_SRC
    ${AUDITMANAGER_UNIFIED_HEADERS}
    ${AUDITMANAGER_UNITY_SRC}
)

if(WIN32)
    #if we are compiling for visual studio, create a sane directory tree.
    if(MSVC)
        source_group("Header Files\\aws\\auditmanager" FILES ${AWS_AUDITMANAGER_HEADERS})
        source_group("Header Files\\aws\\auditmanager\\model" FILES ${AWS_AUDITMANAGER_MODEL_HEADERS})
        source_group("Source Files" FILES ${AWS_AUDITMANAGER_SOURCE})
        source_group("Source Files\\model" FILES ${AWS_AUDITMANAGER_MODEL_SOURCE})
    endif(MSVC)
endif()

set(AUDITMANAGER_INCLUDES
    "${CMAKE_CURRENT_SOURCE_DIR}/include/"
)

add_library(${PROJECT_NAME} ${AUDITMANAGER_SRC})
add_library(AWS::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

set_compiler_flags(${PROJECT_NAME})
set_compiler_warnings(${PROJECT_NAME})

if(USE_WINDOWS_DLL_SEMANTICS AND BUILD_SHARED_LIBS)
    target_compile_definitions(${PROJECT_NAME} PRIVATE "AWS_AUDITMANAGER_EXPORTS")
endif()

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(${PROJECT_NAME} PRIVATE ${PLATFORM_DEP_LIBS} ${PROJECT_LIBS})


setup_install()

install (FILES ${AWS_AUDITMANAGER_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/auditmanager)
install (FILES ${AWS_AUDITMANAGER_MODEL_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/auditmanager/model)

do_packaging()

=== generated/src/aws-cpp-sdk-bcm-data-exports/CMakeLists.txt ===
add_project(aws-cpp-sdk-bcm-data-exports "C++ SDK for the AWS bcm-data-exports service" aws-cpp-sdk-core)

file(GLOB AWS_BCM-DATA-EXPORTS_HEADERS
    "include/aws/bcm-data-exports/*.h"
)

file(GLOB AWS_BCM-DATA-EXPORTS_MODEL_HEADERS
    "include/aws/bcm-data-exports/model/*.h"
)

file(GLOB AWS_BCM-DATA-EXPORTS_SOURCE
    "source/*.cpp"
)

file(GLOB AWS_BCM-DATA-EXPORTS_MODEL_SOURCE
    "source/model/*.cpp"
)

file(GLOB BCM-DATA-EXPORTS_UNIFIED_HEADERS
    ${AWS_BCM-DATA-EXPORTS_HEADERS}
    ${AWS_BCM-DATA-EXPORTS_MODEL_HEADERS}
)

file(GLOB BCM-DATA-EXPORTS_UNITY_SRC
    ${AWS_BCM-DATA-EXPORTS_SOURCE}
    ${AWS_BCM-DATA-EXPORTS_MODEL_SOURCE}
)

if(ENABLE_UNITY_BUILD)
    enable_unity_build("BCM-DATA-EXPORTS" BCM-DATA-EXPORTS_UNITY_SRC)
endif()

file(GLOB BCM-DATA-EXPORTS_SRC
    ${BCM-DATA-EXPORTS_UNIFIED_HEADERS}
    ${BCM-DATA-EXPORTS_UNITY_SRC}
)

if(WIN32)
    #if we are compiling for visual studio, create a sane directory tree.
    if(MSVC)
        source_group("Header Files\\aws\\bcm-data-exports" FILES ${AWS_BCM-DATA-EXPORTS_HEADERS})
        source_group("Header Files\\aws\\bcm-data-exports\\model" FILES ${AWS_BCM-DATA-EXPORTS_MODEL_HEADERS})
        source_group("Source Files" FILES ${AWS_BCM-DATA-EXPORTS_SOURCE})
        source_group("Source Files\\model" FILES ${AWS_BCM-DATA-EXPORTS_MODEL_SOURCE})
    endif(MSVC)
endif()

set(BCM-DATA-EXPORTS_INCLUDES
    "${CMAKE_CURRENT_SOURCE_DIR}/include/"
)

add_library(${PROJECT_NAME} ${BCM-DATA-EXPORTS_SRC})
add_library(AWS::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

set_compiler_flags(${PROJECT_NAME})
set_compiler_warnings(${PROJECT_NAME})

if(USE_WINDOWS_DLL_SEMANTICS AND BUILD_SHARED_LIBS)
    target_compile_definitions(${PROJECT_NAME} PRIVATE "AWS_BCMDATAEXPORTS_EXPORTS")
endif()

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(${PROJECT_NAME} PRIVATE ${PLATFORM_DEP_LIBS} ${PROJECT_LIBS})


setup_install()

install (FILES ${AWS_BCM-DATA-EXPORTS_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/bcm-data-exports)
install (FILES ${AWS_BCM-DATA-EXPORTS_MODEL_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/bcm-data-exports/model)

do_packaging()

=== generated/src/aws-cpp-sdk-cleanroomsml/CMakeLists.txt ===
add_project(aws-cpp-sdk-cleanroomsml "C++ SDK for the AWS cleanroomsml service" aws-cpp-sdk-core)

file(GLOB AWS_CLEANROOMSML_HEADERS
    "include/aws/cleanroomsml/*.h"
)

file(GLOB AWS_CLEANROOMSML_MODEL_HEADERS
    "include/aws/cleanroomsml/model/*.h"
)

file(GLOB AWS_CLEANROOMSML_SOURCE
    "source/*.cpp"
)

file(GLOB AWS_CLEANROOMSML_MODEL_SOURCE
    "source/model/*.cpp"
)

file(GLOB CLEANROOMSML_UNIFIED_HEADERS
    ${AWS_CLEANROOMSML_HEADERS}
    ${AWS_CLEANROOMSML_MODEL_HEADERS}
)

file(GLOB CLEANROOMSML_UNITY_SRC
    ${AWS_CLEANROOMSML_SOURCE}
    ${AWS_CLEANROOMSML_MODEL_SOURCE}
)

if(ENABLE_UNITY_BUILD)
    enable_unity_build("CLEANROOMSML" CLEANROOMSML_UNITY_SRC)
endif()

file(GLOB CLEANROOMSML_SRC
    ${CLEANROOMSML_UNIFIED_HEADERS}
    ${CLEANROOMSML_UNITY_SRC}
)

if(WIN32)
    #if we are compiling for visual studio, create a sane directory tree.
    if(MSVC)
        source_group("Header Files\\aws\\cleanroomsml" FILES ${AWS_CLEANROOMSML_HEADERS})
        source_group("Header Files\\aws\\cleanroomsml\\model" FILES ${AWS_CLEANROOMSML_MODEL_HEADERS})
        source_group("Source Files" FILES ${AWS_CLEANROOMSML_SOURCE})
        source_group("Source Files\\model" FILES ${AWS_CLEANROOMSML_MODEL_SOURCE})
    endif(MSVC)
endif()

set(CLEANROOMSML_INCLUDES
    "${CMAKE_CURRENT_SOURCE_DIR}/include/"
)

add_library(${PROJECT_NAME} ${CLEANROOMSML_SRC})
add_library(AWS::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

set_compiler_flags(${PROJECT_NAME})
set_compiler_warnings(${PROJECT_NAME})

if(USE_WINDOWS_DLL_SEMANTICS AND BUILD_SHARED_LIBS)
    target_compile_definitions(${PROJECT_NAME} PRIVATE "AWS_CLEANROOMSML_EXPORTS")
endif()

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(${PROJECT_NAME} PRIVATE ${PLATFORM_DEP_LIBS} ${PROJECT_LIBS})


setup_install()

install (FILES ${AWS_CLEANROOMSML_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/cleanroomsml)
install (FILES ${AWS_CLEANROOMSML_MODEL_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/cleanroomsml/model)

do_packaging()

=== generated/src/aws-cpp-sdk-cloud9/CMakeLists.txt ===
add_project(aws-cpp-sdk-cloud9 "C++ SDK for the AWS cloud9 service" aws-cpp-sdk-core)

file(GLOB AWS_CLOUD9_HEADERS
    "include/aws/cloud9/*.h"
)

file(GLOB AWS_CLOUD9_MODEL_HEADERS
    "include/aws/cloud9/model/*.h"
)

file(GLOB AWS_CLOUD9_SOURCE
    "source/*.cpp"
)

file(GLOB AWS_CLOUD9_MODEL_SOURCE
    "source/model/*.cpp"
)

file(GLOB CLOUD9_UNIFIED_HEADERS
    ${AWS_CLOUD9_HEADERS}
    ${AWS_CLOUD9_MODEL_HEADERS}
)

file(GLOB CLOUD9_UNITY_SRC
    ${AWS_CLOUD9_SOURCE}
    ${AWS_CLOUD9_MODEL_SOURCE}
)

if(ENABLE_UNITY_BUILD)
    enable_unity_build("CLOUD9" CLOUD9_UNITY_SRC)
endif()

file(GLOB CLOUD9_SRC
    ${CLOUD9_UNIFIED_HEADERS}
    ${CLOUD9_UNITY_SRC}
)

if(WIN32)
    #if we are compiling for visual studio, create a sane directory tree.
    if(MSVC)
        source_group("Header Files\\aws\\cloud9" FILES ${AWS_CLOUD9_HEADERS})
        source_group("Header Files\\aws\\cloud9\\model" FILES ${AWS_CLOUD9_MODEL_HEADERS})
        source_group("Source Files" FILES ${AWS_CLOUD9_SOURCE})
        source_group("Source Files\\model" FILES ${AWS_CLOUD9_MODEL_SOURCE})
    endif(MSVC)
endif()

set(CLOUD9_INCLUDES
    "${CMAKE_CURRENT_SOURCE_DIR}/include/"
)

add_library(${PROJECT_NAME} ${CLOUD9_SRC})
add_library(AWS::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

set_compiler_flags(${PROJECT_NAME})
set_compiler_warnings(${PROJECT_NAME})

if(USE_WINDOWS_DLL_SEMANTICS AND BUILD_SHARED_LIBS)
    target_compile_definitions(${PROJECT_NAME} PRIVATE "AWS_CLOUD9_EXPORTS")
endif()

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(${PROJECT_NAME} PRIVATE ${PLATFORM_DEP_LIBS} ${PROJECT_LIBS})


setup_install()

install (FILES ${AWS_CLOUD9_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/cloud9)
install (FILES ${AWS_CLOUD9_MODEL_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/cloud9/model)

do_packaging()

=== generated/src/aws-cpp-sdk-codepipeline/CMakeLists.txt ===
add_project(aws-cpp-sdk-codepipeline "C++ SDK for the AWS codepipeline service" aws-cpp-sdk-core)

file(GLOB AWS_CODEPIPELINE_HEADERS
    "include/aws/codepipeline/*.h"
)

file(GLOB AWS_CODEPIPELINE_MODEL_HEADERS
    "include/aws/codepipeline/model/*.h"
)

file(GLOB AWS_CODEPIPELINE_SOURCE
    "source/*.cpp"
)

file(GLOB AWS_CODEPIPELINE_MODEL_SOURCE
    "source/model/*.cpp"
)

file(GLOB CODEPIPELINE_UNIFIED_HEADERS
    ${AWS_CODEPIPELINE_HEADERS}
    ${AWS_CODEPIPELINE_MODEL_HEADERS}
)

file(GLOB CODEPIPELINE_UNITY_SRC
    ${AWS_CODEPIPELINE_SOURCE}
    ${AWS_CODEPIPELINE_MODEL_SOURCE}
)

if(ENABLE_UNITY_BUILD)
    enable_unity_build("CODEPIPELINE" CODEPIPELINE_UNITY_SRC)
endif()

file(GLOB CODEPIPELINE_SRC
    ${CODEPIPELINE_UNIFIED_HEADERS}
    ${CODEPIPELINE_UNITY_SRC}
)

if(WIN32)
    #if we are compiling for visual studio, create a sane directory tree.
    if(MSVC)
        source_group("Header Files\\aws\\codepipeline" FILES ${AWS_CODEPIPELINE_HEADERS})
        source_group("Header Files\\aws\\codepipeline\\model" FILES ${AWS_CODEPIPELINE_MODEL_HEADERS})
        source_group("Source Files" FILES ${AWS_CODEPIPELINE_SOURCE})
        source_group("Source Files\\model" FILES ${AWS_CODEPIPELINE_MODEL_SOURCE})
    endif(MSVC)
endif()

set(CODEPIPELINE_INCLUDES
    "${CMAKE_CURRENT_SOURCE_DIR}/include/"
)

add_library(${PROJECT_NAME} ${CODEPIPELINE_SRC})
add_library(AWS::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

set_compiler_flags(${PROJECT_NAME})
set_compiler_warnings(${PROJECT_NAME})

if(USE_WINDOWS_DLL_SEMANTICS AND BUILD_SHARED_LIBS)
    target_compile_definitions(${PROJECT_NAME} PRIVATE "AWS_CODEPIPELINE_EXPORTS")
endif()

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(${PROJECT_NAME} PRIVATE ${PLATFORM_DEP_LIBS} ${PROJECT_LIBS})


setup_install()

install (FILES ${AWS_CODEPIPELINE_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/codepipeline)
install (FILES ${AWS_CODEPIPELINE_MODEL_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/codepipeline/model)

do_packaging()

=== generated/src/aws-cpp-sdk-cost-optimization-hub/CMakeLists.txt ===
add_project(aws-cpp-sdk-cost-optimization-hub "C++ SDK for the AWS cost-optimization-hub service" aws-cpp-sdk-core)

file(GLOB AWS_COST-OPTIMIZATION-HUB_HEADERS
    "include/aws/cost-optimization-hub/*.h"
)

file(GLOB AWS_COST-OPTIMIZATION-HUB_MODEL_HEADERS
    "include/aws/cost-optimization-hub/model/*.h"
)

file(GLOB AWS_COST-OPTIMIZATION-HUB_SOURCE
    "source/*.cpp"
)

file(GLOB AWS_COST-OPTIMIZATION-HUB_MODEL_SOURCE
    "source/model/*.cpp"
)

file(GLOB COST-OPTIMIZATION-HUB_UNIFIED_HEADERS
    ${AWS_COST-OPTIMIZATION-HUB_HEADERS}
    ${AWS_COST-OPTIMIZATION-HUB_MODEL_HEADERS}
)

file(GLOB COST-OPTIMIZATION-HUB_UNITY_SRC
    ${AWS_COST-OPTIMIZATION-HUB_SOURCE}
    ${AWS_COST-OPTIMIZATION-HUB_MODEL_SOURCE}
)

if(ENABLE_UNITY_BUILD)
    enable_unity_build("COST-OPTIMIZATION-HUB" COST-OPTIMIZATION-HUB_UNITY_SRC)
endif()

file(GLOB COST-OPTIMIZATION-HUB_SRC
    ${COST-OPTIMIZATION-HUB_UNIFIED_HEADERS}
    ${COST-OPTIMIZATION-HUB_UNITY_SRC}
)

if(WIN32)
    #if we are compiling for visual studio, create a sane directory tree.
    if(MSVC)
        source_group("Header Files\\aws\\cost-optimization-hub" FILES ${AWS_COST-OPTIMIZATION-HUB_HEADERS})
        source_group("Header Files\\aws\\cost-optimization-hub\\model" FILES ${AWS_COST-OPTIMIZATION-HUB_MODEL_HEADERS})
        source_group("Source Files" FILES ${AWS_COST-OPTIMIZATION-HUB_SOURCE})
        source_group("Source Files\\model" FILES ${AWS_COST-OPTIMIZATION-HUB_MODEL_SOURCE})
    endif(MSVC)
endif()

set(COST-OPTIMIZATION-HUB_INCLUDES
    "${CMAKE_CURRENT_SOURCE_DIR}/include/"
)

add_library(${PROJECT_NAME} ${COST-OPTIMIZATION-HUB_SRC})
add_library(AWS::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

set_compiler_flags(${PROJECT_NAME})
set_compiler_warnings(${PROJECT_NAME})

if(USE_WINDOWS_DLL_SEMANTICS AND BUILD_SHARED_LIBS)
    target_compile_definitions(${PROJECT_NAME} PRIVATE "AWS_COSTOPTIMIZATIONHUB_EXPORTS")
endif()

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(${PROJECT_NAME} PRIVATE ${PLATFORM_DEP_LIBS} ${PROJECT_LIBS})


setup_install()

install (FILES ${AWS_COST-OPTIMIZATION-HUB_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/cost-optimization-hub)
install (FILES ${AWS_COST-OPTIMIZATION-HUB_MODEL_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/cost-optimization-hub/model)

do_packaging()

=== generated/src/aws-cpp-sdk-datazone/CMakeLists.txt ===
add_project(aws-cpp-sdk-datazone "C++ SDK for the AWS datazone service" aws-cpp-sdk-core)

file(GLOB AWS_DATAZONE_HEADERS
    "include/aws/datazone/*.h"
)

file(GLOB AWS_DATAZONE_MODEL_HEADERS
    "include/aws/datazone/model/*.h"
)

file(GLOB AWS_DATAZONE_SOURCE
    "source/*.cpp"
)

file(GLOB AWS_DATAZONE_MODEL_SOURCE
    "source/model/*.cpp"
)

file(GLOB DATAZONE_UNIFIED_HEADERS
    ${AWS_DATAZONE_HEADERS}
    ${AWS_DATAZONE_MODEL_HEADERS}
)

file(GLOB DATAZONE_UNITY_SRC
    ${AWS_DATAZONE_SOURCE}
    ${AWS_DATAZONE_MODEL_SOURCE}
)

if(ENABLE_UNITY_BUILD)
    enable_unity_build("DATAZONE" DATAZONE_UNITY_SRC)
endif()

file(GLOB DATAZONE_SRC
    ${DATAZONE_UNIFIED_HEADERS}
    ${DATAZONE_UNITY_SRC}
)

if(WIN32)
    #if we are compiling for visual studio, create a sane directory tree.
    if(MSVC)
        source_group("Header Files\\aws\\datazone" FILES ${AWS_DATAZONE_HEADERS})
        source_group("Header Files\\aws\\datazone\\model" FILES ${AWS_DATAZONE_MODEL_HEADERS})
        source_group("Source Files" FILES ${AWS_DATAZONE_SOURCE})
        source_group("Source Files\\model" FILES ${AWS_DATAZONE_MODEL_SOURCE})
    endif(MSVC)
endif()

set(DATAZONE_INCLUDES
    "${CMAKE_CURRENT_SOURCE_DIR}/include/"
)

add_library(${PROJECT_NAME} ${DATAZONE_SRC})
add_library(AWS::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

set_compiler_flags(${PROJECT_NAME})
set_compiler_warnings(${PROJECT_NAME})

if(USE_WINDOWS_DLL_SEMANTICS AND BUILD_SHARED_LIBS)
    target_compile_definitions(${PROJECT_NAME} PRIVATE "AWS_DATAZONE_EXPORTS")
endif()

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(${PROJECT_NAME} PRIVATE ${PLATFORM_DEP_LIBS} ${PROJECT_LIBS})


setup_install()

install (FILES ${AWS_DATAZONE_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/datazone)
install (FILES ${AWS_DATAZONE_MODEL_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/datazone/model)

do_packaging()

=== generated/src/aws-cpp-sdk-devops-guru/CMakeLists.txt ===
add_project(aws-cpp-sdk-devops-guru "C++ SDK for the AWS devops-guru service" aws-cpp-sdk-core)

file(GLOB AWS_DEVOPS-GURU_HEADERS
    "include/aws/devops-guru/*.h"
)

file(GLOB AWS_DEVOPS-GURU_MODEL_HEADERS
    "include/aws/devops-guru/model/*.h"
)

file(GLOB AWS_DEVOPS-GURU_SOURCE
    "source/*.cpp"
)

file(GLOB AWS_DEVOPS-GURU_MODEL_SOURCE
    "source/model/*.cpp"
)

file(GLOB DEVOPS-GURU_UNIFIED_HEADERS
    ${AWS_DEVOPS-GURU_HEADERS}
    ${AWS_DEVOPS-GURU_MODEL_HEADERS}
)

file(GLOB DEVOPS-GURU_UNITY_SRC
    ${AWS_DEVOPS-GURU_SOURCE}
    ${AWS_DEVOPS-GURU_MODEL_SOURCE}
)

if(ENABLE_UNITY_BUILD)
    enable_unity_build("DEVOPS-GURU" DEVOPS-GURU_UNITY_SRC)
endif()

file(GLOB DEVOPS-GURU_SRC
    ${DEVOPS-GURU_UNIFIED_HEADERS}
    ${DEVOPS-GURU_UNITY_SRC}
)

if(WIN32)
    #if we are compiling for visual studio, create a sane directory tree.
    if(MSVC)
        source_group("Header Files\\aws\\devops-guru" FILES ${AWS_DEVOPS-GURU_HEADERS})
        source_group("Header Files\\aws\\devops-guru\\model" FILES ${AWS_DEVOPS-GURU_MODEL_HEADERS})
        source_group("Source Files" FILES ${AWS_DEVOPS-GURU_SOURCE})
        source_group("Source Files\\model" FILES ${AWS_DEVOPS-GURU_MODEL_SOURCE})
    endif(MSVC)
endif()

set(DEVOPS-GURU_INCLUDES
    "${CMAKE_CURRENT_SOURCE_DIR}/include/"
)

add_library(${PROJECT_NAME} ${DEVOPS-GURU_SRC})
add_library(AWS::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

set_compiler_flags(${PROJECT_NAME})
set_compiler_warnings(${PROJECT_NAME})

if(USE_WINDOWS_DLL_SEMANTICS AND BUILD_SHARED_LIBS)
    target_compile_definitions(${PROJECT_NAME} PRIVATE "AWS_DEVOPSGURU_EXPORTS")
endif()

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(${PROJECT_NAME} PRIVATE ${PLATFORM_DEP_LIBS} ${PROJECT_LIBS})


setup_install()

install (FILES ${AWS_DEVOPS-GURU_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/devops-guru)
install (FILES ${AWS_DEVOPS-GURU_MODEL_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/devops-guru/model)

do_packaging()

=== generated/src/aws-cpp-sdk-dynamodb/CMakeLists.txt ===
add_project(aws-cpp-sdk-dynamodb "C++ SDK for the AWS dynamodb service" aws-cpp-sdk-core)

file(GLOB AWS_DYNAMODB_HEADERS
    "include/aws/dynamodb/*.h"
)

file(GLOB AWS_DYNAMODB_MODEL_HEADERS
    "include/aws/dynamodb/model/*.h"
)

file(GLOB AWS_DYNAMODB_SOURCE
    "source/*.cpp"
)

file(GLOB AWS_DYNAMODB_MODEL_SOURCE
    "source/model/*.cpp"
)

file(GLOB DYNAMODB_UNIFIED_HEADERS
    ${AWS_DYNAMODB_HEADERS}
    ${AWS_DYNAMODB_MODEL_HEADERS}
)

file(GLOB DYNAMODB_UNITY_SRC
    ${AWS_DYNAMODB_SOURCE}
    ${AWS_DYNAMODB_MODEL_SOURCE}
)

if(ENABLE_UNITY_BUILD)
    enable_unity_build("DYNAMODB" DYNAMODB_UNITY_SRC)
endif()

file(GLOB DYNAMODB_SRC
    ${DYNAMODB_UNIFIED_HEADERS}
    ${DYNAMODB_UNITY_SRC}
)

if(WIN32)
    #if we are compiling for visual studio, create a sane directory tree.
    if(MSVC)
        source_group("Header Files\\aws\\dynamodb" FILES ${AWS_DYNAMODB_HEADERS})
        source_group("Header Files\\aws\\dynamodb\\model" FILES ${AWS_DYNAMODB_MODEL_HEADERS})
        source_group("Source Files" FILES ${AWS_DYNAMODB_SOURCE})
        source_group("Source Files\\model" FILES ${AWS_DYNAMODB_MODEL_SOURCE})
    endif(MSVC)
endif()

set(DYNAMODB_INCLUDES
    "${CMAKE_CURRENT_SOURCE_DIR}/include/"
)

add_library(${PROJECT_NAME} ${DYNAMODB_SRC})
add_library(AWS::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

set_compiler_flags(${PROJECT_NAME})
set_compiler_warnings(${PROJECT_NAME})

if(USE_WINDOWS_DLL_SEMANTICS AND BUILD_SHARED_LIBS)
    target_compile_definitions(${PROJECT_NAME} PRIVATE "AWS_DYNAMODB_EXPORTS")
endif()

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(${PROJECT_NAME} PRIVATE ${PLATFORM_DEP_LIBS} ${PROJECT_LIBS})


setup_install()

install (FILES ${AWS_DYNAMODB_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/dynamodb)
install (FILES ${AWS_DYNAMODB_MODEL_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/dynamodb/model)

do_packaging()

=== generated/src/aws-cpp-sdk-ecr-public/CMakeLists.txt ===
add_project(aws-cpp-sdk-ecr-public "C++ SDK for the AWS ecr-public service" aws-cpp-sdk-core)

file(GLOB AWS_ECR-PUBLIC_HEADERS
    "include/aws/ecr-public/*.h"
)

file(GLOB AWS_ECR-PUBLIC_MODEL_HEADERS
    "include/aws/ecr-public/model/*.h"
)

file(GLOB AWS_ECR-PUBLIC_SOURCE
    "source/*.cpp"
)

file(GLOB AWS_ECR-PUBLIC_MODEL_SOURCE
    "source/model/*.cpp"
)

file(GLOB ECR-PUBLIC_UNIFIED_HEADERS
    ${AWS_ECR-PUBLIC_HEADERS}
    ${AWS_ECR-PUBLIC_MODEL_HEADERS}
)

file(GLOB ECR-PUBLIC_UNITY_SRC
    ${AWS_ECR-PUBLIC_SOURCE}
    ${AWS_ECR-PUBLIC_MODEL_SOURCE}
)

if(ENABLE_UNITY_BUILD)
    enable_unity_build("ECR-PUBLIC" ECR-PUBLIC_UNITY_SRC)
endif()

file(GLOB ECR-PUBLIC_SRC
    ${ECR-PUBLIC_UNIFIED_HEADERS}
    ${ECR-PUBLIC_UNITY_SRC}
)

if(WIN32)
    #if we are compiling for visual studio, create a sane directory tree.
    if(MSVC)
        source_group("Header Files\\aws\\ecr-public" FILES ${AWS_ECR-PUBLIC_HEADERS})
        source_group("Header Files\\aws\\ecr-public\\model" FILES ${AWS_ECR-PUBLIC_MODEL_HEADERS})
        source_group("Source Files" FILES ${AWS_ECR-PUBLIC_SOURCE})
        source_group("Source Files\\model" FILES ${AWS_ECR-PUBLIC_MODEL_SOURCE})
    endif(MSVC)
endif()

set(ECR-PUBLIC_INCLUDES
    "${CMAKE_CURRENT_SOURCE_DIR}/include/"
)

add_library(${PROJECT_NAME} ${ECR-PUBLIC_SRC})
add_library(AWS::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

set_compiler_flags(${PROJECT_NAME})
set_compiler_warnings(${PROJECT_NAME})

if(USE_WINDOWS_DLL_SEMANTICS AND BUILD_SHARED_LIBS)
    target_compile_definitions(${PROJECT_NAME} PRIVATE "AWS_ECRPUBLIC_EXPORTS")
endif()

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(${PROJECT_NAME} PRIVATE ${PLATFORM_DEP_LIBS} ${PROJECT_LIBS})


setup_install()

install (FILES ${AWS_ECR-PUBLIC_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/ecr-public)
install (FILES ${AWS_ECR-PUBLIC_MODEL_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/ecr-public/model)

do_packaging()

=== generated/src/aws-cpp-sdk-ecs/CMakeLists.txt ===
add_project(aws-cpp-sdk-ecs "C++ SDK for the AWS ecs service" aws-cpp-sdk-core)

file(GLOB AWS_ECS_HEADERS
    "include/aws/ecs/*.h"
)

file(GLOB AWS_ECS_MODEL_HEADERS
    "include/aws/ecs/model/*.h"
)

file(GLOB AWS_ECS_SOURCE
    "source/*.cpp"
)

file(GLOB AWS_ECS_MODEL_SOURCE
    "source/model/*.cpp"
)

file(GLOB ECS_UNIFIED_HEADERS
    ${AWS_ECS_HEADERS}
    ${AWS_ECS_MODEL_HEADERS}
)

file(GLOB ECS_UNITY_SRC
    ${AWS_ECS_SOURCE}
    ${AWS_ECS_MODEL_SOURCE}
)

if(ENABLE_UNITY_BUILD)
    enable_unity_build("ECS" ECS_UNITY_SRC)
endif()

file(GLOB ECS_SRC
    ${ECS_UNIFIED_HEADERS}
    ${ECS_UNITY_SRC}
)

if(WIN32)
    #if we are compiling for visual studio, create a sane directory tree.
    if(MSVC)
        source_group("Header Files\\aws\\ecs" FILES ${AWS_ECS_HEADERS})
        source_group("Header Files\\aws\\ecs\\model" FILES ${AWS_ECS_MODEL_HEADERS})
        source_group("Source Files" FILES ${AWS_ECS_SOURCE})
        source_group("Source Files\\model" FILES ${AWS_ECS_MODEL_SOURCE})
    endif(MSVC)
endif()

set(ECS_INCLUDES
    "${CMAKE_CURRENT_SOURCE_DIR}/include/"
)

add_library(${PROJECT_NAME} ${ECS_SRC})
add_library(AWS::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

set_compiler_flags(${PROJECT_NAME})
set_compiler_warnings(${PROJECT_NAME})

if(USE_WINDOWS_DLL_SEMANTICS AND BUILD_SHARED_LIBS)
    target_compile_definitions(${PROJECT_NAME} PRIVATE "AWS_ECS_EXPORTS")
endif()

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(${PROJECT_NAME} PRIVATE ${PLATFORM_DEP_LIBS} ${PROJECT_LIBS})


setup_install()

install (FILES ${AWS_ECS_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/ecs)
install (FILES ${AWS_ECS_MODEL_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/ecs/model)

do_packaging()

=== PKGBUILD ===
# Maintainer: Jeroen Ooms <jeroen@berkeley.edu>

_realname=aws-sdk-cpp
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.11.271
pkgrel=1
pkgdesc="AWS SDK for C++ (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/aws/aws-sdk-cpp"
msys2_references=(
  'archlinux: aws-sdk-cpp'
)
license=('spdx:Apache-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-aws-c-common"
         "${MINGW_PACKAGE_PREFIX}-aws-c-event-stream"
         "${MINGW_PACKAGE_PREFIX}-aws-crt-cpp"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-python")
source=("https://github.com/aws/aws-sdk-cpp/archive/${pkgver}/${_realname}-${pkgver}.tar.gz"
        "aws-sdk-cpp-pr-1333.patch"
        "0001-fix-dll-import-libary-folder.patch")
sha256sums=('bb6d16085cbba289fb544f1d9f9c058257ecef7f416a0b70130aa5a25d128300'
            '1fc2e6bf9e5e1a6d1a80119266d59374f0077534c5e4fd11716a0590e290dba0'
            'ffa3b28970cce12ba24856d9245e2581c6cb4da7faf740377e99f6ef84bcffc4')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Nbp1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  cd "${_realname}-${pkgver}"
  apply_patch_with_msg \
    aws-sdk-cpp-pr-1333.patch \
    0001-fix-dll-import-libary-folder.patch

  # For clang
  sed -e "s/-fPIC//g" -i cmake/compiler_settings.cmake

  find . -name "*.orig" -exec rm -f {} \;
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  mkdir -p "${srcdir}/build-${MSYSTEM}-static" && cd "${srcdir}/build-${MSYSTEM}-static"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake.exe \
      -G "Ninja" \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS=OFF \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DCMAKE_PREFIX_PATH="${MINGW_PREFIX}" \
      -DCMAKE_MODULE_PATH="${MINGW_PREFIX}"/lib/cmake \
      -DAWS_SDK_WARNINGS_ARE_ERRORS=OFF \
      -DBUILD_ONLY="config;identity-management;lambda;s3;sts;transfer" \
      -DENABLE_UNITY_BUILD=ON \
      -DENABLE_TESTING=OFF \
      -DBUILD_DEPS=OFF \
      -DPYTHON_EXECUTABLE=${MINGW_PREFIX}/bin/python \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake.exe --build ./

  mkdir -p "${srcdir}/build-${MSYSTEM}-shared" && cd "${srcdir}/build-${MSYSTEM}-shared"

  LDFLAGS+=" -Wl,--export-all-symbols" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake.exe \
      -G "Ninja" \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DCMAKE_PREFIX_PATH="${MINGW_PREFIX}" \
      -DCMAKE_MODULE_PATH="${MINGW_PREFIX}"/lib/cmake \
      -DAWS_SDK_WARNINGS_ARE_ERRORS=OFF \
      -DBUILD_ONLY="config;identity-management;lambda;s3;sts;transfer" \
      -DENABLE_UNITY_BUILD=ON \
      -DENABLE_TESTING=OFF \
      -DBUILD_DEPS=OFF \
      -DPYTHON_EXECUTABLE=${MINGW_PREFIX}/bin/python \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake.exe --build ./
}

package() {
  cd "${srcdir}/build-${MSYSTEM}-static"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install ./

  cd "${srcdir}/build-${MSYSTEM}-shared"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install ./

  cd "${srcdir}/${_realname}-${pkgver}"
  install -Dm644 LICENSE "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
